gi-gio-2.0.32: Gio bindings

Copyright | Will Thompson and Iñaki García Etxebarria
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | Safe-Inferred
Language | Haskell2010

GI.Gio.Objects.UnixFDList

Contents

- Exported types
- Methods
  - append
  - get
  - getLength
  - new
  - newFromArray
  - peekFds
  - stealFds

Description

A `GUnixFDList` contains a list of file descriptors. It owns the file descriptors that it contains, closing them when finalized.

It may be wrapped in a `GUnixFDMessage` and sent over a `Socket` in the `G_SOCKET_FAMILY_UNIX` family by using `socketSendMessage` and received using `socketReceiveMessage`.

Before 2.74, `<gio/gunixfdlist.h>` belonged to the UNIX-specific GIO interfaces, thus you had to use the `gio-unix-2.0.pc` pkg-config file when using it.

Since 2.74, the API is available for Windows.

Synopsis

- newtype UnixFDList = UnixFDList (ManagedPtr UnixFDList)
- class (GObject o, IsDescendantOf UnixFDList o) => IsUnixFDList o
- toUnixFDList :: (MonadIO m, IsUnixFDList o) => o -> m UnixFDList
- unixFDListAppend :: (HasCallStack, MonadIO m, IsUnixFDList a) => a -> Int32 -> m Int32
- unixFDListGet :: (HasCallStack, MonadIO m, IsUnixFDList a) => a -> Int32 -> m Int32
- unixFDListGetLength :: (HasCallStack, MonadIO m, IsUnixFDList a) => a -> m Int32
- unixFDListNew :: (HasCallStack, MonadIO m) => m UnixFDList
- unixFDListNewFromArray :: (HasCallStack, MonadIO m) => [Int32] -> m UnixFDList
- unixFDListPeekFds :: (HasCallStack, MonadIO m, IsUnixFDList a) => a -> m [Int32]
- unixFDListStealFds :: (HasCallStack, MonadIO m, IsUnixFDList a) => a -> m [Int32]

# Exported types

newtype UnixFDList Source #

Memory-managed wrapper type.

Constructors

UnixFDList (ManagedPtr UnixFDList) |

#### Instances

Instances details

Eq UnixFDList Source # |
Instance details Defined in GI.Gio.Objects.UnixFDList Methods (==) :: UnixFDList -> UnixFDList -> Bool Source # (/=) :: UnixFDList -> UnixFDList -> Bool Source #
GObject UnixFDList Source # |
Instance details Defined in GI.Gio.Objects.UnixFDList
ManagedPtrNewtype UnixFDList Source # |
Instance details Defined in GI.Gio.Objects.UnixFDList Methods toManagedPtr :: UnixFDList -> ManagedPtr UnixFDList Source #
TypedObject UnixFDList Source # |
Instance details Defined in GI.Gio.Objects.UnixFDList Methods glibType :: IO GType Source #
HasParentTypes UnixFDList Source # |
Instance details Defined in GI.Gio.Objects.UnixFDList
IsGValue (Maybe UnixFDList) Source # | Convert `UnixFDList` to and from `GValue`. See `toGValue` and `fromGValue`.
Instance details Defined in GI.Gio.Objects.UnixFDList Methods gvalueGType_ :: IO GType Source # gvalueSet_ :: Ptr GValue -> Maybe UnixFDList -> IO () Source # gvalueGet_ :: Ptr GValue -> IO (Maybe UnixFDList) Source #
type ParentTypes UnixFDList Source # |
Instance details Defined in GI.Gio.Objects.UnixFDList type ParentTypes UnixFDList = '[Object]

class (GObject o, IsDescendantOf UnixFDList o) => IsUnixFDList o Source #

Type class for types which can be safely cast to `UnixFDList`, for instance with `toUnixFDList`.

#### Instances

Instances details

(GObject o, IsDescendantOf UnixFDList o) => IsUnixFDList o Source # |
Instance details Defined in GI.Gio.Objects.UnixFDList

toUnixFDList :: (MonadIO m, IsUnixFDList o) => o -> m UnixFDList Source #

Cast to `UnixFDList`, for types for which this is known to be safe. For general casts, use `castTo`.

# Methods

### Click to display all available methods, including inherited ones

Expand

#### Methods

append, bindProperty, bindPropertyFull, forceFloating, freezeNotify, get, getv, isFloating, notify, notifyByPspec, peekFds, ref, refSink, runDispose, stealData, stealFds, stealQdata, thawNotify, unref, watchClosure.

#### Getters

getData, getLength, getProperty, getQdata.

#### Setters

setData, setDataFull, setProperty.

## append

unixFDListAppend Source #

Arguments

:: (HasCallStack, MonadIO m, IsUnixFDList a) |
=> a | `list`: a `UnixFDList`
-> Int32 | `fd`: a valid open file descriptor
-> m Int32 | Returns: the index of the appended fd in case of success, else -1 (and `error` is set) (Can throw `GError`)

Adds a file descriptor to `list`.

The file descriptor is duplicated using `dup()`. You keep your copy of the descriptor and the copy contained in `list` will be closed when `list` is finalized.

A possible cause of failure is exceeding the per-process or system-wide file descriptor limit.

The index of the file descriptor in the list is returned. If you use this index with `unixFDListGet` then you will receive back a duplicated copy of the same file descriptor.

Since: 2.24

## get

unixFDListGet Source #

Arguments

:: (HasCallStack, MonadIO m, IsUnixFDList a) |
=> a | `list`: a `UnixFDList`
-> Int32 | `index_`: the index into the list
-> m Int32 | Returns: the file descriptor, or -1 in case of error (Can throw `GError`)

Gets a file descriptor out of `list`.

`index_` specifies the index of the file descriptor to get. It is a programmer error for `index_` to be out of range; see `unixFDListGetLength`.

The file descriptor is duplicated using `dup()` and set as close-on-exec before being returned. You must call `close()` on it when you are done.

A possible cause of failure is exceeding the per-process or system-wide file descriptor limit.

Since: 2.24

## getLength

unixFDListGetLength Source #

Arguments

:: (HasCallStack, MonadIO m, IsUnixFDList a) |
=> a | `list`: a `UnixFDList`
-> m Int32 | Returns: the length of `list`

Gets the length of `list` (ie: the number of file descriptors contained within).

Since: 2.24

## new

unixFDListNew Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> m UnixFDList | Returns: a new `UnixFDList`

Creates a new `UnixFDList` containing no file descriptors.

Since: 2.24

## newFromArray

unixFDListNewFromArray Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> [Int32] | `fds`: the initial list of file descriptors
-> m UnixFDList | Returns: a new `UnixFDList`

Creates a new `UnixFDList` containing the file descriptors given in `fds`. The file descriptors become the property of the new list and may no longer be used by the caller. The array itself is owned by the caller.

Each file descriptor in the array should be set to close-on-exec.

If `nFds` is -1 then `fds` must be terminated with -1.

Since: 2.24

## peekFds

unixFDListPeekFds Source #

Arguments

:: (HasCallStack, MonadIO m, IsUnixFDList a) |
=> a | `list`: a `UnixFDList`
-> m [Int32] | Returns: an array of file descriptors

Returns the array of file descriptors that is contained in this object.

After this call, the descriptors remain the property of `list`. The caller must not close them and must not free the array. The array is valid only until `list` is changed in any way.

If `length` is non-`Nothing` then it is set to the number of file descriptors in the returned array. The returned array is also terminated with -1.

This function never returns `Nothing`. In case there are no file descriptors contained in `list`, an empty array is returned.

Since: 2.24

## stealFds

unixFDListStealFds Source #

Arguments

:: (HasCallStack, MonadIO m, IsUnixFDList a) |
=> a | `list`: a `UnixFDList`
-> m [Int32] | Returns: an array of file descriptors

Returns the array of file descriptors that is contained in this object.

After this call, the descriptors are no longer contained in `list`. Further calls will return an empty list (unless more descriptors have been added).

The return result of this function must be freed with `free`. The caller is also responsible for closing all of the file descriptors. The file descriptors in the array are set to close-on-exec.

If `length` is non-`Nothing` then it is set to the number of file descriptors in the returned array. The returned array is also terminated with -1.

This function never returns `Nothing`. In case there are no file descriptors contained in `list`, an empty array is returned.

Since: 2.24